import es
from spe.games import cstrike
from spe.games import shared
import spe

events = {}

def load():
	#shared
	if not es.exists("command","spe_createent"):
		es.regcmd("spe_createent","speess/createent", "Creates an entity")
	if not es.exists("command","spe_entexists"):
		es.regcmd("spe_entexists","speess/entexists", "Check if an entity exists")
	if not es.exists("command","spe_getweaponindex"):
		es.regcmd("spe_getweaponindex","speess/getweaponindex", "Gets the index of the weapon")
	if not es.exists("command","spe_getslotweapon"):
		es.regcmd("spe_getslotweapon","speess/getslotweapon", "Gets a weapon from a player's slot")
	if not es.exists("command","spe_removeent"):
		es.regcmd("spe_removeent","speess/removeent", "Removes an entity")
	if not es.exists("command","spe_setentname"):
		es.regcmd("spe_setentname","speess/setentname", "Sets an entity's name")
	if not es.exists("command","spe_setkeyvalue"):
		es.regcmd("spe_setkeyvalue","speess/setkeyvalue", "Sets a key value")
	#cstrike
	if not es.exists("command","spe_respawn"):
		es.regcmd("spe_respawn","speess/respawn", "Respawns a player")
	if not es.exists("command","spe_changeteam"):
		es.regcmd("spe_changeteam","speess/changeteam", "Changes a player's team")
	if not es.exists("command","spe_getactiveweaponindex"):
		es.regcmd("spe_getactiveweaponindex","speess/getactiveweaponindex", "Gets the player's active weapon index")
	#own
	if not es.exists("command","spe_getclassname"):
		es.regcmd("spe_getclassname","speess/getclassname", "Gets a classname from an index")
	#hooking
	if not es.exists("command","spe_prehook"):
		es.regcmd("spe_prehook","speess/prehook", "Prehook an event")
	if not es.exists("command","spe_unprehook"):
		es.regcmd("spe_unprehook","speess/unprehook", "Unprehook an event")

def unload():
	#unhook all
	for eventname in events:
		spe.unregisterPreHook(eventname, all_hooks)

def createent():
	args = es.getargc()
	if args > 2:
		name = es.getargv(2)
		variable = es.getargv(1)
		pointer = shared.createEntity(name)
		index = pointertoindex(pointer,name)
		es.set(variable,index)
	elif args > 1:
		name = es.getargv(1)
		shared.createEntity(name)
	else:
		es.dbgmsg(0,'Syntax: spe_createent [variable] <classname>')

def entexists():
	args = es.getargc()
	if args > 2:
		variable = es.getargv(1)
		index = int(es.getargv(2))
		if not indexexists(index):
			es.set(variable,0)
		else:
			es.set(variable,1)
	else:
		es.dbgmsg(0,'Syntax: spe_entexists <variable> <index>')

def indexexists(index):
	myvar = shared.entityByIndex(index)
	if not myvar:
		return False
	else:
		return True

def getweaponindex():
	args = es.getargc()
	if args > 3:
		variable = es.getargv(1)
		userid = int(es.getargv(2))
		classname = es.getargv(3)
		pointer = shared.ownsWeapon(userid,classname)
		index = pointertoindex(pointer,classname)
		es.set(variable,index)
	else:
		es.dbgmsg(0,'Syntax: spe_getweaponindex <var> <userid> <classname>')

def getslotweapon():
	args = es.getargc()
	if args > 3:
		variable = es.getargv(1)
		userid = int(es.getargv(2))
		slot = int(es.getargv(3))
		if not useridexists(userid):
			es.dbgmsg(0,'spe_getslotweapon: No such userid')
			return
		pointer = shared.getWeaponFromSlot(userid,slot)
		index = pointertoindex(pointer)
		es.set(variable,index)
	else:
		es.dbgmsg(0,'Syntax: spe_getslotweapon <var> <userid> <slot>')

def removeent():
	args = es.getargc()
	if args > 1:
		index = int(es.getargv(1))
		if not indexexists(index):
			es.dbgmsg(0,'spe_removeent: No such index')
			return
		shared.removeEntityByIndex(index)			
	else:
		es.dbgmsg(0,'Syntax: spe_removeent <index>')

def setentname():
	args = es.getargc()
	if args > 2:
		index = int(es.getargv(1))
		name = es.getargv(2)
		if not indexexists(index):
			es.dbgmsg(0,'spe_setentname: No such index')
			return
		shared.setStringKeyvalue(index,'targetname',name)	
	else:
		es.dbgmsg(0,'Syntax: spe_setentname <index> <name>')

def setkeyvalue():
	args = es.getargc()
	if args > 3:
		index = int(es.getargv(1))
		keyname = es.getargv(2)
		keyvalue = es.getargv(3)
		if not indexexists(index):
			es.dbgmsg(0,'spe_setkeyvalue: No such index')
			return
		shared.setStringKeyvalue(index,keyname,keyvalue)
	else:
		es.dbgmsg(0,'Syntax: spe_setkeyvalue <index> <keyname> <keyvalue>')

def respawn():
	args = es.getargc()
	if args > 1:
		userid = int(es.getargv(1))
		if not useridexists(userid):
			es.dbgmsg(0,'spe_respawn: No such userid')
			return
		cstrike.respawn(userid)
	else:
		es.dbgmsg(0,'Syntax: spe_respawn <userid>')

def changeteam():
	args = es.getargc()
	if args > 2:
		userid = int(es.getargv(1))
		teamnum = int(es.getargv(2))
		if not useridexists(userid):
			es.dbgmsg(0,'spe_changeteam: No such userid')
			return
		cstrike.switchTeam(userid,teamnum)
	else:
		es.dbgmsg(0,'Syntax: spe_changeteam <userid> <teamnum>')

def getactiveweaponindex():
	args = es.getargc()
	if args > 2:
		variable = es.getargv(1)
		userid = int(es.getargv(2))
		pointer = cstrike.getActiveWeapon(userid)
		index = pointertoindex(pointer)
		if not useridexists(userid):
			es.dbgmsg(0,'spe_getactiveweaponindex: No such userid')
			return
		es.set(variable,index)
	else:
		es.dbgmsg(0,'Syntax: spe_getactiveweaponindex <variable> <userid>')

def getclassname():
	args = es.getargc()
	if args > 2:
		variable = es.getargv(1)
		index = int(es.getargv(2))
		if not indexexists(index):
			es.dbgmsg(0,'spe_getclassname: No such index')
			return
		classname = indextoclassname(index)
		es.set(variable,classname)
	else:
		es.dbgmsg(0,'Syntax: spe_getclassname <variable> <index>')

def prehook():
	args = es.getargc()
	if args > 2:
		eventname = es.getargv(1)
		block = es.getargv(2)
		if not eventname in events:
			spe.registerPreHook(eventname, all_hooks)
			events[eventname] = {}
			events[eventname][block] = True
		else:
			if not block in events[eventname]:
				events[eventname][block] = True
			else:
				es.dbgmsg(0,'spe_prehook: Pre-hook already exists')
	else:
		es.dbgmsg(0,'Syntax: spe_prehook <event-name> <script/block>')

def unprehook():
	args = es.getargc()
	if args > 2:
		eventname = es.getargv(1)
		block = es.getargv(2)
		if eventname in events:
			if block in events[eventname]:
				del events[eventname][block]
				if len(events[eventname]) == 0:
					spe.unregisterPreHook(eventname, all_hooks)
					del events[eventname]
			else:
				es.dbgmsg(0,'spe_unprehook: Pre-hook does not exist')
		else:
			es.dbgmsg(0,'spe_unprehook: Pre-hook does not exist')
	else:
		es.dbgmsg(0,'Syntax: spe_prehook <event-name> <script/block>')

def pointertoindex(pointer,classname=None):
	if classname:
		entlist = es.createentitylist(classname)
	else:
		entlist = es.createentitylist()
	for index in entlist:
		if pointer == shared.entityByIndex(index):
			return index
	return -1

def indextoclassname(index):
	entlist = es.createentitylist(index)
	return entlist[index]['classname']

def useridexists(userid):
	userid2 = es.getuserid(userid)
	return userid == userid2

def all_hooks(ev):
	eventname = ev["spe_eventname"]
	for var in ev:
		es.set(var,ev[var])
	if eventname in events:
		for block in events[eventname]:
			es.doblock(block)